#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>
#define tamBuffer 10000

/*Variaveis globais*/
pthread_t geraPrimos;/*thread1*/
pthread_t confereConj;/*thread2*/
pthread_mutex_t buffer_mutex;
int buffer[tamBuffer];
sem_t buffer_full, buffer_empty;
int topo = 0, qt = 0;

/*Funcoes utilizadas*/
void inicializaSemaforo();
int geraPrimo(int *chao);
int verificaConjecturaParaNum(int num);
void *escritor();
void *leitor();

void modoDeUso() {
   printf("Modo de uso:\n\t$dividir numero\n\n\tnumero deve ser par.");
}
   

int main(int argc, char *argv[]){

   /*testa entrada*/
   if(argc != 2){
      modoDeUso();
      exit(-1);
   }
   qt = atoi(argv[1]);
   /*testa se entrada eh par maior que*/
   if(qt < 4 || qt % 2 != 0){
      modoDeUso();
      exit(-1);
   }
   inicializaSemaforo();

   pthread_create(&geraPrimos, NULL, escritor, NULL);
   pthread_create(&confereConj, NULL,  leitor, NULL);

   pthread_join(geraPrimos, NULL);
   pthread_join(confereConj, NULL);

   return 0;
}
/*Inicializa os semaforos*/
void inicializaSemaforo(){

   sem_init(&buffer_full, 0, tamBuffer);
   sem_init(&buffer_empty, 0, 0);

}
/*Devolve o primeiro numero primo maior que chao*/
int geraPrimo(int *chao){

   int i = 2;
   while(1){

      while(i <= *chao){
	 if(*chao % i == 0){
	    if(i == *chao){
	       return *chao;
	    }(*chao)++;
	 }i++;
      }

   }
}

/*Verifica se num eh soma de dois impares presentes na estrutura compartilhada,
 *Devolve 1 caso afirmativo ou 0 caso contrario
 */
int verificaConjecturaParaNum(int num){

   int i, j;

   for(i = 0; i < topo; i++){
      for(j = 0; i + j < topo; j++){
	 if(num == buffer[i] + buffer[i + j]){
	    printf("%d = %d + %d\n", num, buffer[i], buffer[i+j]);
	    return 1;
	 }
      }
   }
   /*Nãencontrou na estrutura dois impares que somados dao o num*/
   return 0;
}

/*Armazena os numeros primos na estrutura compartilhada*/
void *escritor(){

   int n;
   int p = 2;

   while(p < qt){

      n = geraPrimo(&p);p++;
      sem_wait(&buffer_full);
      pthread_mutex_lock(&buffer_mutex);
      /*Acesso a estrutura de dados compartilhada*/
      buffer[topo++] = n;
      if(topo == tamBuffer){
	 printf("Entrada fornecida eh muito grande, por favor forneca uma entrada menor que 50.000\n");
	 exit(-1);
      }
      pthread_mutex_unlock(&buffer_mutex);
      sem_post(&buffer_empty);

   }
}
/*Verifica se os pares menores que a entrada do programa sao soma de primos atraves da estrutura compartilhada*/
void *leitor(){

   int lim = 4, k = 0;

   while(lim <= qt){


      pthread_mutex_lock(&buffer_mutex);
      /*Acesso a estrutura de dados compartilhadaprintf("comecar a testar %d\n", lim); */
      if(topo != 0)
	 k = verificaConjecturaParaNum(lim);
      if(k == 1)lim += 2;

      pthread_mutex_unlock(&buffer_mutex);


   }
}


